package node;

import utils.ObjectQueue;
import capsule.Agent;


public abstract class AgentAccounter extends EnvironmentComponent {
    // Keeps track of running time of agents

    protected ObjectQueue queue;
  
    protected RessourceUsage usage=null; // For controlling the agent

    protected long start=0;
    protected long stop=0;
    protected boolean running=false;



    void setRessourceUsage(RessourceUsage usage) {
	// Must be called before 'run'
	this.usage=usage;
    }

    
    public ObjectQueue getQueue() {return queue;}

    synchronized void startClock() {
	// Should be called before each execution of the agent.
	running=true;
	start=System.currentTimeMillis();
    }

    protected synchronized void stopClock() {
	// Should be called after each execution of the agent.
	stop=System.currentTimeMillis();
	usage.addExecTime(stop-start);
	running=false;
    }

    // Methods for the RessourceController (can also call startClock())
    synchronized boolean running() {
	return running;
    }

    synchronized long startTime() {
	return start;
    }

    synchronized long stopTime() {
	return stop;
    }

    ObjectQueue queue() {
	return queue;
    }

    protected void init(Node n, Agent a, ObjectQueue q) {
	queue=q;
	init(n,a);
    }

}
