package node;

import filter.*;
import java.util.*;

public  class CustomerPolicyGen extends PolicyGenerator {
    // Implements an open yet safe policy. All agents can listen to traffic to/from
    // their home network and to all ipsec traffic.


    public CustomerPolicyGen(Node n) {
	isSuper=false; // The customer is not a super-user.
	mustAuth=true; // The customer must authenticate.
	priority=50;
	init(n);
    }

    protected  Vector createFilterVector(Profile u) {
	// A customer is allowed to see the own traffic, ipsec and ike.
	Vector v=new Vector(2);
	ListOfRanges homeNet=u.homeNets();
	Filter ownTraffic=new Filter(homeNet, homeNet, new All(), new All(), -1, -1);
	// all packets to/from their home network in complete length.

	Filter ipsec=new Filter(new All(), new All(), new All(), new ListOfRanges(50,51), -1, -1);
	Filter ike=new Filter(new All(), new All(), new ListOfRanges(500), new ListOfRanges(17), -1, -1); // udp on port 500.

	v.addElement(ownTraffic);
	v.addElement(ipsec);
	v.addElement(ike);
	return v;
    }


}
