package node;

import clientserver.DummyResult;
import clientserver.Result;
import utils.ObjectQueue;
import node.services.Service;

import capsule.*;
import filter.*;
import java.io.*;
import java.util.*;


public class NodeServiceDelivery extends ServiceDelivery {
    // Forwards the result of a service request to the agent.
    
    public NodeServiceDelivery(Agent a, Node n) {
	init(n, a);
	queue=new ObjectQueue(node.Q_LEN());// The same len as the packet queue?
    }

    public void run() {
	// Implements the life of the agent. 
	Service service;
	try {
	    while(true) { // some rate limiting possible here
		startClock();
		service=(Service) queue.get(); // Blocks if no packet there.
		agent.handleService(service); // The call to the agent.
		stopClock();
	    }
	} catch (SecurityException e) { // The agents actions may cause a security exception or class loader exceptions.
	    reactUponSecurityViolation(e);
	} catch (NoClassDefFoundError e) { // Usually this error should not be caught.
	    // However, the classloader can cause a security exception which will
	    // lead to a NoClassDefFoundError. So we have to translate that here.
	    System.err.println("-->No CLASS def found (in AgentWrapper): "+e);
	    reactUponSecurityViolation(new Exception("Class loader security error."));
	}
    }
}
