package node;

import java.io.*;

public class PacketFactory {
    // This class is used to parse an ip packet from a byte stream.
    protected int bufSize;
    protected byte[] buf;

    protected long packetCntr=0; // debugging

    public IPPacket create(DataInputStream raw, int nrBytes) {
	// for separation of concerns, nrBytes should also be read here!
 	IPPacket ip=null;
	long timeStamp;
	//System.out.println("reading packet with: "+nrBytes+" bytes.");
	try {
	    timeStamp=toNumber(4,raw);// seconds
	    timeStamp*=1000000; // micro sec precision assumed.
	    timeStamp+=toNumber(4,raw);
	    buf=new byte[nrBytes];
	    int r=0;
	    int h=0;
	    while (r<nrBytes) { // Read the bytes in chunks.
		h=raw.read(buf,r,nrBytes-r); // Read all in one (performance improvement > factor 3).
		// could be replaced by readFully
		if(h<0) {
		    System.err.println("Too little bytes read. Expecting: "+nrBytes+" read: "+r);
		    break;
		}
		r+=h;
	    }
	    ip=new IPPacket(buf,timeStamp);
	} catch(IOException e)  {
	    System.err.println("Error while assembling ip packet: "+e);
	}
	packetCntr++;
	return ip;
    }


    protected int toNumber(int bytes, DataInputStream raw) {
	int ret=0;
	for (int i=0; i< bytes;) {
	    try {
		ret+=raw.read();
	    } catch(Exception e) {
		System.err.println("Error while reading the header: "+e);
	    }
	    i++;
	    if (i<bytes) ret<<=8;
	}
	return ret;
    }

}
