package node;

import java.io.Serializable;
import java.util.Vector;

import filter.*;

public class Profile implements Serializable{
    // This container represents a user (client/customer..) in the user database.
    // Contains all the rights a user has.
    // Dynamically produced rights are generated by the policy generator.

    protected String identity; // Unique identifier (also pgp id).
    protected ListOfRanges homeNets;
    protected PolicyGenerator policyGen; // Can generate a policy tailored for that user.
    protected Vector services; // Additional allowed node services.

    public Profile(String id, ListOfRanges hn, PolicyGenerator pg, Vector srv) {
	identity=id; homeNets=hn; policyGen=pg; services=srv;
    }

    public boolean equals(Profile e) {
	return identity.equals(e.identity);
    }
    
    public String identity() {
	return identity;
    }
    public ListOfRanges homeNets() {
	return homeNets;
    }
    public PolicyGenerator policyGen() {
	return policyGen;
    }

    public Vector services() {
	return services;
    }

    public String toString() {
	StringBuffer buf=new StringBuffer();
	buf.append("Profile for ");
	buf.append(identity);
	buf.append(" owning ");
	buf.append(homeNets.toString());
	buf.append(" is Policy type: " );
	buf.append(policyGen.toString());
	return new String(buf);
    }
}
