package node;

public class ServerPorts {
    // This class helps the Registry to keep track of the used port numbers.
    protected boolean[] ports; // true if port number index+base is occupied.
    protected int base; 
    protected int pos=0;// For circular seek-> port numbers are unused for longer times.
    public ServerPorts(int baseNr, int nr) {
	if(Receiver.portOK(baseNr) && Receiver.portOK(baseNr+nr)) {
	    ports=new boolean[nr];
	    base=baseNr;
	    initPorts();
	} else {
	    System.err.println("Illegal port block assignment in ServerPorts!");
	}
    }

    public synchronized int assignAfreeNr() {
	for(int i=0; i<ports.length; i++) {
	    incPos();
	    if(!ports[pos]) { // port not occupied.
		ports[pos]=true;
		return base+pos;
	    } 
	}
	System.err.println("Warning! Didn't find a free server port number.");
	return -1;
    }

    public synchronized void free(int i) {
	if((i>=base) && (i<(base+ports.length)))
	ports[i-base]=false;
    }

    public synchronized boolean isFree(int nr) {
	return ports[nr];
    }

    protected synchronized void initPorts() {
	for(int i=0; i< ports.length; i++) {
	    ports[i]=false;
	}
    }

    protected synchronized void incPos() {
	pos++;
	if (pos>=ports.length) pos=0;
    }
}
