package node;

import utils.*;
import java.net.*;
import java.io.*;
import java.util.*;


public class T_ComponentDummy implements Runnable {
    // Replaces the T_Component for testing.
    // Sends packets to the Receiver to be forwarded to the agent.

    protected static int pckSize=1400;

    protected String server; // To get the name of  the server
    protected int port;
    protected int interval; // Waiting time between delivering packets.
    protected Socket socket;
    protected byte[] message; // Sending always the same packet
    protected boolean ok=true;

    public T_ComponentDummy(int interval, String server, int port) {
	//this.node=node;
	this.interval=interval;
	this.server=server;
	this.port=port;
    }

    public void run() {
	generateDefaultPacket();
	try{
	    socket=new Socket(server, port);
	    while(true) {
		sendMessage();
		updateTime();
		//generateDefaultPacket();
		try {Thread.sleep(interval);}catch(InterruptedException e){};
	    }
	} catch(Exception e) {
	    System.out.println("T_ComponentDummy exits with: "+e);    
	}
    }

    protected void generateDefaultPacket() {
	int len=pckSize+10;
	message=new byte[len];

	int ipLen=pckSize;
	
	updateTime();
	copyIntoMessage(pckSize, 0, 2); // The t-compo protocol

	copyIntoMessage(69, 10 , 1); // Set necessary ip header stuff.
	copyIntoMessage(0, 11 , 1); // Set necessary ip header stuff.
	copyIntoMessage(pckSize, 12 , 2); // Set the correct packet len in the ip header

	Random rnd=new Random();

	byte[] data=new byte[pckSize-20];
	rnd.nextBytes(data);
	for(int i=0; i<pckSize-20; i++) {// Init data part;
	    //message[i+30]=data[i]; // init with rnd
	    message[i+30]=(byte) i; // for ping like look (else comment out).

	}
	//testMessageWithTestIPPacket(time*1000);
    }

    protected void updateTime() {
	// updates/sets the time in the default packet.
	long time=System.currentTimeMillis();
	long upT=time/1000;
	long lowT= (time%1000)*1000;
	//System.out.println((new Date(time))+" T "+time+" U: "+upT+" L; "+lowT);
	copyIntoMessage(upT, 2, 4);
	copyIntoMessage(lowT, 6, 4);

    }

    protected void sendMessage() throws IOException {
	OutputStream os=socket.getOutputStream();
	os.write(message);
    }

    protected void copyIntoMessage(long val, int from, int nrObytes) {
	int to=from+nrObytes;
	for(int i=to; i>from; i--) {
	    message[i-1]=(byte) val;
	    val>>=8;
	}
    }

    protected void testMessageWithTestIPPacket(long time) {
	byte[] ip=new byte[pckSize];
	for(int i=10; i< pckSize+10; i++){
	    ip[i-10]=message[i];
	}
	PacketCharacterPrinter ipp=new PacketCharacterPrinter();
	System.out.println(ipp.toString(new IPPacket(ip,time)));
    }

}
