package application;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;

import utils.*;

public class Trigger extends Frame implements ActionListener{
    // Creates a packet and the hash of its udp payload.
    // Sends it ev. several times (as fast as possible) using udp.
    // This application can thus be used to trigger an agent that was prepared
    // to wait for a packet with a specific hash (e.g. TriggerAgent).

    protected static Hash hashFct=new EasyHash(); // Use the same as in capsule.HashAgent. MD5hash
    protected static String create="Create";
    protected static String send="Send";
    protected static int textWidth=30;
    
    protected TextField targetF, portF, lenF, timesF;
    protected TextArea hashF,statusF;

    protected Label targetL, portL, lenL, timesL, hashL, statusL;

    protected Button createB, sendB;

    protected String target="balu.unibe.ch";
    protected int port=8888;
    protected int len=1000;
    protected int times=1;
    protected byte[] data=new byte[len];


    public Trigger() {
	setLayout(new GridLayout(7,2,5,5));
	//panel.add(quit); panel.add(query); panel.add(execReq); panel.add(help);

	initGUIelements();
	setInitTextValues();
	addGUIelements();
	addThisListener();
    }


    protected void initGUIelements() {
	targetL=new Label("Target"); portL=new Label("Port"); lenL=new Label("Data len"); timesL=new Label("Send nr.of times"); hashL=new Label("Hash"); statusL=new Label("Status");
	targetF=new TextField(textWidth); portF=new TextField(textWidth); lenF=new TextField(textWidth); timesF=new TextField(textWidth);

	statusF=new TextArea(5,20);
	hashF=new TextArea(5,20);

	hashF.setEditable(false); statusF.setEditable(false);
	createB=new Button(create); sendB=new Button(send);
    }

    protected void addGUIelements() {
	add(targetL); add(targetF); 
	add(portL); add(portF); 
	add(lenL); add(lenF); 
	add(timesL); add(timesF); 
	add(createB);add(sendB);
	add(hashL); add(hashF);
	add(statusL); add(statusF);    
    }

    protected void addThisListener() {
	createB.addActionListener(this);
	sendB.addActionListener(this);
    }
     
    protected void setInitTextValues() {
	targetF.setText(target); 
	portF.setText(string(port)); 
	lenF.setText(string(len)); 
	timesF.setText(string(times)); 
	statusF.setText("Enter send-info, create a packet.");
    }

    protected void extractUserSendingInput() {
	int h;
	String t;
	target=targetF.getText(); 
	t=portF.getText(); 
	h=parse(t);
	if(h>0) port=h; 
	portF.setText(string(port)); 
	t=timesF.getText();
	h=parse(t);
	if(h>0) times=h;
	timesF.setText(string(times)); 
    }

    protected void extractUserCreatingInput() {
	String t;
	int h;
	t=lenF.getText(); 
	h=parse(t);
	if(h>0) {
	    len=h;
	}
	lenF.setText(string(len)); 
    }


    protected String string(int i) {
	return (new Integer(i)).toString();
    }

    protected int parse(String s) {
	int ret=-1;
	try {
	    ret=Integer.parseInt(s);
	} catch(NumberFormatException e) {
	}
	return ret;
    }
    
    public void actionPerformed(ActionEvent e) {
	String command=e.getActionCommand(); 

 	if(command.equals(send)) {
	    send();
	} else if(command.equals(create)) {
	    create();
	}
    }

    protected void send() {
	extractUserSendingInput();
	DatagramPacket packet=null;
	try {
	    InetAddress ip= InetAddress.getByName(target);
	    packet=new DatagramPacket(data, len , ip, port);
	    DatagramSocket socket=new DatagramSocket();
	    for(int i=0; i<times; i++) {
		socket.send(packet); // Sending!
	    }
	    statusF.setText(times+ " packet(s) sent.");
	}catch( Exception e) {
	    statusF.setText(e.toString());
	}
    }

    protected void create() {
	extractUserCreatingInput();
	setData();
	printHash(createHash());
// 	PacketPrinter pr=new PacketPrinter();
// 	System.out.println(pr.data(data));
    }
 
    protected void setData() {
	// Fill them with random bytes.
	Random rnd=new Random();
	data=new byte[len];
	rnd.nextBytes(data);
	data[0]=0;data[1]=0;data[len-2]=0;data[len-1]=0; // Delimit test.
    }

    protected byte[] createHash() {
	return hashFct.hash(data, 0, len);
    }

    protected void printHash(byte[] hash) {
	StringBuffer buf=new StringBuffer();
	buf.append('{');
	for(int i=0; i<16; i++) {
	    buf.append(hash[i]);
	    if(i<15) {
		buf.append(", ");
		if(i%4==3)
		    buf.append('\n');
	    }
	}
	buf.append("};");
	hashF.setText(new String(buf));
	statusF.setText("Packet and hash created.");
    }


    public static void main(String[] args) {
	Frame f=new Trigger();
	f.setTitle("Trigger");
	//f.setSize(500,400);
	f.pack();
	f.show();

	
    }
}
