package application;

import java.awt.*;
import java.awt.event.*;


public class UDPBlaster extends Frame implements ActionListener, AdjustmentListener {
    // A GUI for blasting UDP traffic at different speed/throughput.
    // Note that the application shows more traffic than actually generated,
    // since the packet dropping is neglected.

    //protected static final int max=1000; // Slider resolution.

    protected static final int delayMax=3000; // 2000
    

    protected int initPckSz=1000; //100

    protected Scrollbar scroll=new Scrollbar(Scrollbar.HORIZONTAL, 1, 1, 1, delayMax);
    protected TextField bandwidth=new TextField(20);
    protected Label psLabel=new Label("Packet size (bytes):");
    protected TextField packetSize=new TextField((new Integer(initPckSz)).toString(),20);


    protected UDPSender sender;
    //    protected Panel panel=new Panel();

    public UDPBlaster() {
	initUDPSender();


	setLayout(new GridLayout(4,1,10,10));
	//panel.add(quit); panel.add(query); panel.add(execReq); panel.add(help);

	setScrollParameters();


	bandwidth.setEditable(false);
	scroll.setSize(new Dimension(500,200));
	bandwidth.addActionListener(this);
	packetSize.addActionListener(this);
	scroll.addAdjustmentListener(this);

	add(scroll);
	add(bandwidth);
	add(psLabel);
	add(packetSize);

    }

    public void actionPerformed(ActionEvent e) {
	String command=e.getActionCommand(); 
	//System.out.println(e); //getValue();
 	if(e.getSource()==packetSize) {
	    changePacketSize(command);
	}
	
    }
    public void adjustmentValueChanged(AdjustmentEvent ev) {
       	//System.out.println(ev);
	//int delay=delayMax/scroll.getValue(); // Revert the non-linear effect of delay on bandwidth.
	int delay=delayMax-scroll.getValue();
	//System.out.println("New delay: "+delay);
	sender.delay=delay;
    }

    protected void changePacketSize(String size) {
	int s=-1;
	try {
	    s=Integer.parseInt(size);
	} catch (NumberFormatException e) {
	}
	if((s<0) || (s>65507)) 
	    System.err.println("Illegal packet size: "+size);
	else {
	    initPckSz=s;
	    sender.cont=false; // Stop the old sender
	    Thread.yield();
	    initUDPSender(); // Make a new one.
	    
	}   
    }


    protected void initUDPSender() {
	sender=new UDPSender("fermat.unibe.ch", 9999, new byte[initPckSz], delayMax, bandwidth);
 	(new Thread(sender)).start();
    }

    protected void setScrollParameters() {

	scroll.setBlockIncrement(delayMax/10);
	scroll.setUnitIncrement(delayMax/100);
	scroll.setVisibleAmount(1);

// 	System.out.println("BI "+scroll.getBlockIncrement());
// 	System.out.println("UI "+scroll.getUnitIncrement());
// 	System.out.println("VA "+scroll.getVisibleAmount());
    }

    public static void main(String[] args) {
	Frame f=new UDPBlaster();
	f.setTitle("UDPBlaster");
	//f.setSize(500,400);
	f.pack();
	f.show();

	
    }
}
