package application;

import java.net.*;
import java.awt.TextField;

public class UDPSender implements Runnable {
    protected String target;
    protected int port;
    protected DatagramSocket socket;
    protected DatagramPacket packet;
    protected long last;
    protected long bytes=0;
    protected int packetLen;

    protected TextField output;

    public boolean cont=true; // To stop the loop
    public long delay=1000;



    public UDPSender(String target, int port, byte[] data, long delay, TextField tf) {
	this.target=target;
	this.port=port;
	this.delay=delay;
	output=tf;
	
	if(!setDGPacket(data)) cont=false;
    }

    public boolean setData(byte[] data) {
	// obsolete
	cont=false; // restart the sender after changing the 
	return setDGPacket(data);
    }
    
    public void run() {
	last=System.currentTimeMillis();
	long now, diff;
	
	try {
	    socket=new DatagramSocket();
	    while(cont) {
		long c=delay;
		while(c>0) {c--; dummyWait();} // Waiting loop.
		socket.send(packet); // Sending!
		bytes+=packetLen;
		now=System.currentTimeMillis();
		diff=now-last;
		if(diff > 1000) { // print the bandwith consumption.
		    reportBW(diff);
		    last=now;
		}
	    } 
	} catch (Exception e) {System.err.println(e);}

    }


    protected boolean setDGPacket(byte[] data) {
	// using the iv vars.
	try {
	    InetAddress ip= InetAddress.getByName(target);
	    packetLen=data.length;
	    packet=new DatagramPacket(data, packetLen , ip, port);
	}catch( Exception e) {
	    System.out.println(e);
	    return false;
	}
	return true;
    }

    protected void dummyWait() {
	Thread.yield();
    }

    protected void reportBW(long diff) {
	output.setText("Sending: "+(bytes/diff)+" KBps.");
	bytes=0;
    }

//     public static void main(String[] args) {
// 	UDPSender sender=new UDPSender("localhost", 9999, new byte[1500], 0 ,);
// 	(new Thread(sender)).start();
//     }
}
