package clientserver;
// For results via agent call-back.

import node.IPPacket;
import java.util.*;

import java.io.*;

public class NumericResults extends Result {
    // Carrier for one or many numeric results. Not optimized.

    public boolean alarm=false;
    public boolean piggyback=false;// Are there results in the vector

    public double result;
    public long time;
    public Vector results; // Contains NumericResults
    
    public NumericResults() { // Use this as final result (the super const will set last=true).
	super(null);
    }

    public NumericResults(Result r) {
	// like reverse casting
	super(r.reply, r.last);
	setPacket(r.ip);
    }

    public NumericResults(long t, double r) {
	super(null,false);
	result=r;
	time=t;
    }

    public NumericResults(long t, Vector res) {
	super(null,false);
	results=res;
	time=t;
	piggyback=true;
    }

    public void setAlarm(String info) {
	alarm=true;
	reply=info;
    }

    public void plotPrint(PrintWriter ps)  throws IOException {
	// Print the sub-results in gnuplot style.
	NumericResults sr;
	if(results==null) return;

	for (Enumeration e=results.elements(); e.hasMoreElements(); ) {
	    sr=(NumericResults) e.nextElement();
	    ps.print(sr.time);
	    ps.print('\t');
	    ps.print(sr.result);

	    ps.print('\t');
	    if(sr.alarm)
		ps.print(1);
	    else
		ps.print(0);
	    ps.print('\n');

	}
		 
    }

}
