package clientserver;

public class ProtoConsts {
    // Stores constants that are relevant for the networking connection protocl.
    // Warning: changes come only to effect, when recompiling the class that USES
    // these constants (Java feature with static final?).
    public static final byte QUERY=1;
    public static final byte QUERY_RES=2;
    public static final byte EXEC_REQ=3;
    public static final byte EXEC_ACK=4;
    public static final byte RESULT=5;
    public static final byte END=6; // obsolete, result has a bit indicating this
    public static final byte CALLBACK=7; 
    public static final byte ROUTE_UPDATE=8; 


    // Encodings:
    public static final byte PLAIN=0; // No encoding.
    public static final byte FULL_PGP_v263i=1; // PGP enc. and auth. with version 2.6.3i
    public static final byte SIGN_PGP_v263i=2; // PGP  with version 2.6.3i auth only.

    // Implementation:
    public static final int PORT=1998; // The server's well-known port //OBSOLETE
    public static final int CALLBACK_PORT=19988; // The port where agents can call back. (not well known)
    public static final int ROUTING_PORT=1997; // The port of the servers waiting for routing information (well-known) // OBSOLETE
    public static final int VR_PORT_OFFSET=1000; // vr t=bone should be started with the port nodeport + offset. 
    // Messages: 
    // Query types: see in clientserver.Query

}
