package clientserver;

import java.io.*;

public class ProtocolObject implements Serializable {
    // encapsulates for auth/encryption
    public String senderID;
    public byte encoding;
    public byte messageType;
    public ForwardingDescriptor forwarding;
    public ByteArray message;

    public ProtocolObject(String id,  byte enc, byte mesT, Message mes) {
	this(id, enc, mesT, new ByteArray(new byte[0]));
	ByteArray ba=mes.exportToByteArray();
	message=ba;
    }

    public ProtocolObject(ProtocolObject c) {
	// Special copy constructor. Needed to keep a copy for forwarding.
	senderID=c.senderID;
	encoding=c.encoding;
	messageType=c.messageType;
	forwarding=c.forwarding;
	message=new ByteArray(c.message); // to keep the original message with low cost.
    }

    public ProtocolObject(String id,   byte enc, byte mesT, ByteArray mes) {
	senderID=id;
	encoding=enc;
	messageType=mesT;
	message=mes;
    }

    public String toString() {
	StringBuffer buf=new StringBuffer();

	buf.append("ProtocolObject:\n");
	buf.append("From: ");
	buf.append(senderID);
	buf.append("\nEncoding: ");
	buf.append(encoding);
	buf.append("\nMessagetype: ");
	buf.append(messageType);
	return new String(buf);
    }



    public static ProtocolObject readProtocolObjectFrom(InputStream is) {
	ProtocolObject r=null;
	ObjectInputStream in;
	try {
	    in=new ObjectInputStream(is);
	    r= (ProtocolObject) in.readObject();
	} catch (Exception e) {
	    System.err.println(e);
	}
	return r;
    }
}
