package clientserver;

import node.Node;
import topology.RoutingTable;

import java.io.*;
import java.net.*;
import java.util.Vector;

public class RouteUpdateConnectionHandler extends ConnectionHandler { 
    // Handles route updates arriving from the server socket.
    protected Node node;
    protected RoutingTable table;

    public RouteUpdateConnectionHandler(RoutingTable t, Node n) {
	node=n;
	table=t;
    }

    public void run() {
	if (socket==null) {
	    System.err.println("RouteUpdateConnectionHandler did not get a ready socket!");
	}
	RoutingUpdate rUpdate=null;
	ProtocolObjectSenderReceiver posr=new ProtocolObjectSenderReceiver(socket,  node.NODE_ID()); // We use protocol objects to send/receive updates.
	//System.out.println("Routing update arrives at: "+node.NODE_ID());
	 
	DecodingResult dr=posr.receive(node.PASSPHRASE());
	Object m;
	if(dr != null) {
	    // Possible auth check here!
	    ProtocolObject po=dr.protocolObject();
	    if(po.messageType==ProtoConsts.ROUTE_UPDATE) {
		m=Message.readObjectFrom(po);
		if (m instanceof RoutingUpdate) {
		    rUpdate= (RoutingUpdate) m;
		    table.routeUpdate(rUpdate.updates, po.senderID); // Consider the new routes in the table.
		} else 
		    System.err.println("Warning: receceived routing update with wrong class type: "+m.toString());
	    } else 
		System.err.println("Warning: receceived routing update with wrong proto type.");
	}
	posr.closeSocket();	
    }
}

