package config;

import java.io.*;

public abstract class ConfigObjectManager  {
    // A factory for config objects of all kinds. Allows the persistence and
    // offline manipulation fo configuration objects.
    // Currently,  UserDBManager implements such a class to dynamically
    // manage the user database (user ID- user profile), and NodeConfigManager
    // handles the persistent node configurations.
    protected String diskPath;
    
    public ConfigObject loadFromDisk(String filename) {
	ConfigObject ret=null;
	Object o=null;
	
	ObjectInputStream in;
	try {
	    in=new ObjectInputStream(new FileInputStream(diskPath+filename));
	    o= in.readObject();
	    ret=(ConfigObject) o;
	} catch (Exception e) {
	    System.err.println(e);
	}
	return ret;
    }

    public void saveToDisk(String filename, ConfigObject co) {
	try {
	    ObjectOutputStream out=new ObjectOutputStream(new FileOutputStream(diskPath+filename));
	    out.writeObject(co);
	} catch (Exception e) {
	    System.err.println("Failed to save config object! Exception: "+e);
	}
    }
    
    public void init(String path) {
	// Should be called in the constructor.
	diskPath=path;
    }

    public abstract ConfigObject defaultConfig();

}
