package netgui;

import java.awt.*;
import java.util.*;

public class Domain  extends RellocNetComponent{

    protected Vector routers=new Vector();
    protected int r=50;
 

    public Domain(int nr, int r) {
	setInitPos(nr);
	if(r>0) 
	    this.r=r;
    }
    
    public void paintOn(Graphics g) {
	if (selected) 
	    g.setColor(selectedColor);
	else 
	    g.setColor(foreground);
	int d=2*r;
	g.fillOval(x-r,y-r,d,d);
	paintRouters(g);
    }

    public int radius() {return r;}

    NetComponent touching(int x, int y) {
	NetComponent router=checkRouterTouch(x,y); 
	if(router!=null) return router;
	int dx=(x-this.x);
	dx=dx*dx;
	int dy=(y-this.y);
	dy=dy*dy;
	if (dx+dy <= r*r) return this;
	return null;
    }

    void addRouter(Router r) {
	routers.addElement(r);
    }

    protected void paintRouters(Graphics g) {
	Router r;
	for(Enumeration e=routers.elements(); e.hasMoreElements(); ) {
	    r=(Router) e.nextElement();
	    r.paintOn(g);
	}
    }

    protected NetComponent checkRouterTouch(int x, int y) {
	Router r;
	for(Enumeration e=routers.elements(); e.hasMoreElements(); ) {
	    r=(Router) e.nextElement();
	    if(r.touches(x,y)) return r;
	}
	return null;
    }

    void move(int x, int y) {
	int dx=x-this.x;
	int dy=y-this.y;
	
	Router r;
	for(Enumeration e=routers.elements(); e.hasMoreElements(); ) {
	    r=(Router) e.nextElement();
	    r.relMove(dx,dy);
	}
	super.move(x,y);
    }

    protected void setInitPos(int nr) {
	x=nr*40;
	y=nr*40;
    }

}
