package netgui;

import java.awt.*;
import java.awt.event.*;


public class Main extends Frame implements ActionListener {
    protected Button newDomain=new Button("New Domain");
    protected Button newRouter=new Button("New Router");
    protected Button newEndUser=new Button("New Host");

    protected NetCanvas canvas=new NetCanvas();

    public Main() {

	newDomain.addActionListener(this); 
	newRouter.addActionListener(this); 
	newEndUser.addActionListener(this); 

	canvas.addMouseListener(canvas);
	canvas.addMouseMotionListener(canvas);

	Panel p=new Panel();
	p.add(newDomain); p.add(newRouter); p.add(newEndUser);

	add(p, BorderLayout.NORTH);	
	add(canvas, BorderLayout.SOUTH);	
    }

    public void actionPerformed(ActionEvent e) {
	String command=e.getActionCommand(); 
	if(command.equals("New Domain")) {
	    addNewDomain();
	} else if(command.equals("New Router")) {
	    addNewRouter();
	} else if(command.equals("New Host")) {
	    addNewEndUser();
	}

    }

    protected void addNewDomain() {
	// Dialog to ask properties
       	canvas.addNewDomain();
    }

    protected void addNewRouter() {
	canvas.addNewRouter();
    }

    protected void addNewEndUser() {
	canvas.addNewEndUser();
    }



    public static void main(String[] args) {
	Frame f=new Main();
	f.setTitle("Test");
	//f.setSize(200,200);
	f.pack();
	f.show();
    }
}
