package node;


import utils.ObjectQueue;

import java.util.*;

import capsule.Agent;
import clientserver.Result;
import filter.*;

public class DummyReceiver extends Receiver {
    // Creates packets for performance tests.
    protected static int delay=0;
    protected static int every=1; // nur nach 10 packeten mal ein yield
    protected static int packetLen=40;

    protected Random rnd =new Random(1);
    protected IPPacket ipp;
    protected ObjectQueue queue;

    protected PacketFactory factory=new PacketFactory();
    protected int nrOfPckts;
    protected Filter filter;
    

    protected boolean stopped=false; // Synchronisation. If the agent stops at 'init', then
    // the receiver is probably not started yet, but allready stopped!

    protected long connectionStart; // for performance tests.

    public DummyReceiver (int p, ObjectQueue q, Filter f, Node nod, Agent a) {
	init(nod,a);
	queue=q;
	filter=f;
	nrOfPckts=f.packets().getNr();
	generatePacket();
    }


    public void run() {
	//Thread.currentThread().setPriority(Thread.MAX_PRIORITY-1);
	// A high priority guarantees, that a DoS attack cannot
	// slow down the packet reception which is used as a measurement
	// of the cpu consumption of the agents (see RessourceController).
	connectionStart=System.currentTimeMillis(); // performance tests.
	int i=0;
	for (; i <nrOfPckts ; i++) {
	    if(i%every == every-1)
		waitAlittle();
	    generatePacket();
	    queue.put(ipp);
	}
	long connectionEnd=System.currentTimeMillis();
	long totTime=connectionEnd-connectionStart;
	System.out.println("Dummy ended after: "+totTime+" ms.");
	double Bps=((double) i*packetLen)/ totTime;
	System.out.println("Packets: "+i+" KB/s: "+ Bps );
    }


    protected void waitAlittle() {
	try {Thread.sleep(1000);}catch(InterruptedException e){};
	//	if(queue.used()>=40) { //CRITICAL_Q_LEN // Seems slower
	    for (int i=0; i<delay ; i++) {
		Thread.yield();
	    }
	    //}
    }

    protected void generatePacket() {
	byte[] data= new byte[packetLen];
	//init(data,(byte) 50); 
	randData(data);
	ipp=new IPPacket(data, 1000*System.currentTimeMillis());
    }

    protected void init(byte[] d, byte val) {
	for (int i=0; i<d.length; i++) {
	    d[i]=val;
	}
    }


    protected void randData(byte[] d) {
	rnd.nextBytes(d);
// 	for (int i=0; i<d.length; i++) {
// 	    d[i]=(byte) (badRnd.nextByte()-128);
// 	}
    }



}
