package node;
import capsule.Agent;

public abstract class EnvironmentComponent implements Runnable {
    protected Thread myThread; // For stopping.
    protected boolean informRegistry=true; // Inform the registry after stopping. 
    // This is necessary since either ResultChannel or this object can cause the
    // registry to call the stop() functions.

    protected Node node;// Mainly to reach the Registry and for initial configurations.
    protected Agent agent;

    protected void init(Node n, Agent a) {
	node=n;
	agent=a;
    }

    void setThread(Thread mt) {
	myThread=mt;
    }

    public abstract void run(); // all components are runnable.

    synchronized void stop(boolean informRegistry) {
	this.informRegistry=informRegistry;
	if (Thread.currentThread()!=myThread) {// Stops the loop the hard way. Takes some time!    
	    if(myThread!=null) myThread.stop();
	    System.out.println("Thread STOPPED");
	}
    }



}
