package node.services;
import utils.ObjectQueue;


public class AlarmClock implements Runnable {
    // Wake up helper for the WakeUpHandler.
    protected static int aGiffy=100; // How many millisecs is the minimum waiting unit.
    protected long sleepTime;
    protected int wakeups;
    protected Service request; // To answer with the same number.
    
    protected ObjectQueue deliveryQueue;

    AlarmClock(int x, int n, Service req, ObjectQueue q) {
	sleepTime=x*aGiffy;
	wakeups=n;
	request=req;
	deliveryQueue=q;
    };
 
    public void run(){
	for(int i=0; i<wakeups; i++) {
	    try {
		Thread.sleep(sleepTime);
		deliveryQueue.put(composeWakeUpCall(i)); // Put the anser in the queue. An alternative would be a direct call to the agent. The problem is that then, the security exceptions must be caught.
	    } catch(InterruptedException e) {
		System.err.println("AlarmClock: "+e);
	    }
	}
    }

    protected Service composeWakeUpCall(int cnt) {
	Service call=new Service(request);
	call.setArgs(new Integer(cnt));
	return call;
    }
}
