package node.services;

import node.*;
import java.util.Vector;


public class AllAgentsStopHandler extends ServiceHandler {
    // Handles node-stop requests by the agent.
    // Only privileged agents (root) should be able to do this.

    protected Registry registry;
    protected Policy policy;
    
    ServiceHandler newServiceHandlerFor(ExecutionEnvironment ev, Node n) {
	AllAgentsStopHandler ret=new AllAgentsStopHandler(type);
	ret.registry=n.registry();
	ret.policy=ev.policy();
	return ret;
    }

    AllAgentsStopHandler(int type) {
	// Non-complete constructor , which is then used as a factory.
	this.type=type;
    };
 

    boolean startService(Service req) {
	//even if it has the permission to do the service, check if root.
	if(!policy.isSuperUser()) return false;
	registry.killAllAgents();
	return true;
    }

    void stopService() {};


}
