package node.services;

public class ServiceDescription {
    // A human-readable description of the data type when requesting and
    // a service or getting the result of a service. Both cases use
    // a Service object which carries the data in the 'arguments' field,
    // which is an Object. Therefore, we need to somehow declare what
    // this object is expected to be.

    // The structure should be a java.util.Vector with multiple
    // jdk objects. The use of special purpose classes is discurraged, because
    // both client and server side would have to know these classes.
    // Also common 'clientserver' classes can be used.
    // If there's no service delivery, the ret description should say 'none'.
    // If the value doesn't matter (is unused) it should say 'null'.

    protected String description;
    protected String argumentTypes;
    protected String returnTypes;

    public ServiceDescription(String desc, String args, String ret) {
	description=desc;
	argumentTypes=args;
	returnTypes=ret;
    }
    
    public String description() {return description;}
    public String argumentTypes() {return argumentTypes;}
    public String returnTypes() {return returnTypes;}

    public String toString() {
	StringBuffer buf=new StringBuffer();
	buf.append(description);
	buf.append("\n  Arg: ");
	buf.append(argumentTypes);
	buf.append("\n  Ret: ");
	buf.append(returnTypes);
	buf.append("\n ");
	return new String(buf);
    }

}
