package node.services;

import node.*;
import java.util.Vector;
/* Written by Manuel Gnter. All rights reserved, no warranties */


public abstract class ServiceHandler {
    // A service handler can fulfil a service of a particular type.
    // The service handler class is also a factory for handlers beyond the 'new' method.
    // This is particularly useful for instantiating handler from template handler
    // objects (See ServiceDatabase). 
    protected int type;
    protected ServiceList serviceList; // For access between services (across a list).
    public int type() {return type;}

    abstract ServiceHandler newServiceHandlerFor(ExecutionEnvironment ev, Node n);
    // The handler can be init with the current execution environment. The service list is used to init a service with an existing other service on the list.

    void setListPointer(ServiceList list) {
	serviceList=list;
    }

    abstract boolean startService(Service req) ;

    abstract void stopService();

}
