package node.services;

import java.util.*;
/* Written by Manuel Gnter. All rights reserved, no warranties */

public class ServiceList { // Used in service list.
    // A list of service handlers.
    protected Hashtable table;

    public ServiceList(Hashtable t) {
	table=t;
    }

   public void addService(long uses, ServiceHandler h, ServiceDescription descr) {
	table.put(new Integer(h.type()), new ServiceListEntry(uses,h, descr));
    }


   void addService(ServiceListEntry se) {
	table.put(new Integer(se.type()), se);
   }

    void initListPointer() {
	// Add a reference from the handler to the list in order to allow
	// the access from one service to another.
	ServiceListEntry entry;
	for(Enumeration e=table.elements(); e.hasMoreElements(); ) {
	    entry=(ServiceListEntry) e.nextElement();
	    entry.handler().setListPointer(this);
	}
    }

    public boolean startService(Service req) {
	Object o=table.get(new Integer(req.type()));
	if (o==null) return false;
	ServiceListEntry e=(ServiceListEntry) o;
	if(e.goodForUse())
	    return e.handler().startService(req);
	return false;
    }

    public void stopAllHandlers() { // cleaning up...
	ServiceListEntry entry;
	for(Enumeration e=table.elements(); e.hasMoreElements(); ) {
	    entry=(ServiceListEntry) e.nextElement();
	    entry.handler().stopService();
	}
    }

    ServiceListEntry getServiceListEntry(int servicenr) {
	return (ServiceListEntry) table.get(new Integer(servicenr));
    }

    public Hashtable table() {
	return table;
    }

    public String toString() {
	StringBuffer buf=new StringBuffer();
	ServiceListEntry entry;
	buf.append('\n');

	for(Enumeration e=table.elements(); e.hasMoreElements(); ) {
	    entry=(ServiceListEntry) e.nextElement();
	    buf.append(entry.toString());
	    buf.append("\n\n");
	}
	return new String(buf);
    }
 
}
