package node.services;

import node.*;
import java.util.Vector;


public class WakeUpHandler extends DeliveringServiceHandler {
    Thread alarmThread=null; // A thread that wakes up regularly.

    ServiceHandler newServiceHandlerFor(ExecutionEnvironment ev, Node n) {
	return new WakeUpHandler(n, ev, type);
    }

    WakeUpHandler(int type) {
	// Non-complete constructor , which is then used as a factory.
	this.type=type;
    };
 
    WakeUpHandler(Node n, ExecutionEnvironment ev, int typ) {
	// Only the ServiceDatabase uses the constructor, to assure the type consistency.
	initDelivery(n,ev,typ);
    }

    boolean startService(Service req) {
	// Should be used only once! Enforce this in the ServiceDatabase!
	Object o;
	Vector v;
	int x,n;
	if (req.arguments() instanceof Vector) { // Check the correctness of
	    v=(Vector) req.arguments();  // the arguments.
	    if (v.size()>=2) {
		Service reply=new Service(req); // copy.
		x=assignInt(v.firstElement());
		n=assignInt(v.lastElement()); // ok, should be second..
		if ((x>0) && (n>-1)) {
		    alarmThread=new Thread(new AlarmClock(x,n, reply, deliveryQueue));
		    alarmThread.start();
		    return true;
		}
	    }
	}
	return false;
    }

    void stopService() {
	if(alarmThread !=null) 
	    alarmThread.stop();
    }

    protected int assignInt(Object o) {
	if (o instanceof Integer) { // Check the correctness of
	    return ((Integer) o).intValue();
	}
	return -1;
    }

}
