package node.services;

import java.util.Vector;
/* Written by Manuel Gnter. All rights reserved, no warranties */

public class Service {
    protected static long current=0;

    protected int type;
    protected Vector args;
    protected long number; // Id for the service request.


    public Service(int t, Vector a) {
	type=t;
	args=a;
	number=newNr();
    }

    public Service(int t, Object a) { // For convenience with a single arg.
	type=t;
	setArgs(a);
	number=newNr();
    }

    public Service(Service s) {
	// Copy constructor for the service handlers. Does not copy args!
	type=s.type;
	number=s.number;
    }

    public int nrOfArgs() {
	return args.size();
    }

    public int type() {
	return type;
    }
    public Vector arguments() {
	return args;
    }

    public Object first() { // For convenience with a single arg.
	return args.firstElement();
    }
    
    public long number() {
	return number;
    }
    
    void setArgs(Vector v) {
	args=v;
    }

    void setArgs(Object o) { // For convenience with a single arg.
	args=new Vector();
	args.addElement(o);
    }

    public boolean equals(Service s) {
	// A request matches the corresponding delivery (reply).
	return (type==s.type) && (number==s.number);
    }

    public String toString() {
	return "Service type: "+type+" number: "+number+" args: "+args;

    }

    synchronized protected static long newNr() {
	// For unique service numbers.
	return current++;
    }

}
