package node.services;

import java.util.Vector;
/* Written by Manuel Gnter. All rights reserved, no warranties */

public class ServiceListEntry { // Used in service list.
    protected long uses; // how many times the service can be used.
    protected ServiceHandler handler;
    protected int type;
    protected ServiceDescription description; // or name of the service.

    public ServiceListEntry(long u, ServiceHandler h, ServiceDescription d) {
	uses=u;
	handler=h;
	type=h.type();
	description=d;
    }

    public boolean equals(ServiceListEntry o) {
	return type==o.type;
    }

    public int type() {
	return type;
    }

    public long uses() {
	return uses;
    }

    public ServiceDescription description() {
	return description;
    }

    public boolean goodForUse() {
	return --uses>-1;
    }

    public ServiceHandler handler() {
	return handler;
    }

    public String toString() {
	StringBuffer buf=new StringBuffer();
	buf.append("Service number: ");
	buf.append(type);
	buf.append(" Description: ");
	buf.append(description.toString());
	buf.append(" Uses: ");
	buf.append(uses);
	return new String(buf);
    }
}
