package topology;

import java.io.*;
import java.util.*;


public class NeighborRecordParser extends TableRecordParser {
    // Parses and outputs NeighborRecord

    protected void write(TableRecord rec) throws IOException {
	if(rec instanceof NeighborRecord) {
	    NeighborRecord nr=(NeighborRecord) rec;
	    String s=" "+separator+" ";
	    for(Enumeration e=nr.neighbors.elements(); e.hasMoreElements();) {
		output.write((String) e.nextElement());
		if(e.hasMoreElements()) output.write(s);
	    }
	} else {
	    System.err.println("Wrong class for record entry: "+rec);
	}
    }
   
    protected TableRecord parseRecord() {
	Vector v=new Vector();
	String s=giveNextToken(parser);
	while(s!=null) {
	    v.addElement(s);
	    s=giveNextToken(parser);
	} 
	return new NeighborRecord(null, v);
    }


}
