package topology;

import java.io.Serializable;
import java.util.*;
import utils.AddressCalculator;

public class RouteRecord extends TableRecord  implements Serializable {
    // Represents an entry in a RoutingTable (does not have to be a TableRecord..)
    public int ip;
    public String nextHop; // node ID;
    public int hopCount=0;

    public RouteRecord(int i, String n) {
	ip=i;
	nextHop=n;
	key=calcKey(ip);
    }
    

    public  String toString() {
	StringBuffer buf=new StringBuffer();
	buf.append("RouteRecord for: ");
	buf.append(key);
	buf.append(" ip: ");
	buf.append(AddressCalculator.toString(ip));
	buf.append(" nextHop: ");
	buf.append(nextHop);
	buf.append(" hops: ");
	buf.append(hopCount);
	return new String(buf);
    }

    static String calcKey(int key) {
	// Hashtable needs an Object as the key. We use the 10.11.13 form.
	return AddressCalculator.toString(key);
    }
}
