package topology;

import java.io.*;
import java.util.*;

import filter.*;
import node.*;

public class TableParser {
    TableRecordParser parser;

    TableParser(TableRecordParser recP) {
	parser=recP;
    }

   protected void writeTxtToDisk(String name, TopologyTable o) {
	try {
	    parser.setWriter(new FileWriter(name));
	    TableRecord p;
	    for(Enumeration e=o.elements(); e.hasMoreElements(); ) {

		p=(TableRecord) e.nextElement();
		parser.write(p.key, p);
	    }	    
	} catch (Exception e) {
	    System.err.println("TableParser couldn't write "+o);
	}
    }

    protected TopologyTable readTxtFromDisk(String name) {
	// Gives the raw table info. Use copy constructor to init a special type of thable.
	TopologyTable ret=new TopologyTable();
	try {
	    parser.setReader(new FileReader(name));
	    TableRecord p;

	    while((p=parser.read()) != null) {
		ret.put(p.key, p);
	    }
	} catch (Exception e) {
	    System.err.println(e+"TableParser couldn't read object as text from "+name);
	}
	return ret;
    }

    public static void main(String args[]) {
	// testing
	TableParser p=new TableParser(new NodeRecordParser());
	TopologyTable tab=p.readTxtFromDisk("nodes.global.config");
	System.out.println(tab);
	p.writeTxtToDisk("nodes.global.config",tab);
    }
}
